/****************************************************************************************
    Copyright 2004 uja
    Copyright 2004 Trolltech (Qt3)

    This file is part of Fleur: game header
*****************************************************************************************/

// Game-Headerdatei Fleur

#ifndef CHIPS_H
#define CHIPS_H

#include "config.h"
#include <qcanvas.h>
#include <qtimer.h>
#include <qfile.h>

class chips:public QCanvas
{
  Q_OBJECT
  
  public:
  chips(QWidget* parent=0);
  QCanvasPixmapArray* my_pixarray;
  QCanvasPixmapArray* my_goverarray;
  QCanvasPixmapArray* my_pausearray;
  QCanvasPixmapArray* my_cursorarray;
  QCanvasSprite* p_sprite[SMAX]; // anders ging es leider nicht
  QCanvasSprite* p_pause;
  QCanvasSprite* p_gover;
  QCanvasSprite* p_cursor;
  
  bool aktiv,wertung,schwerkraft,pausiert;
  int punkte,multi,modus,zeit,gewaehlt,tic;
  int f[SMAX],h_liste[SMAX];
  QString levelname; 	      
  QTimer* my_timer;
  QTimer* my_stopper;
  
  private:
  
  int  in_liste(int,int[SMAX]);
  void add_liste(int,int[SMAX]);
  void merge_liste(int[SMAX],int[XMAX]);
  void reset_timer();
  void game_over();
  void zeige_feld(int);
  void weiter();
  bool check_zug(int,int);
  void linear(int,int,int[XMAX]);
  void eine_ecke(int,int,int[2*XMAX]);
  void zwei_ecken(int,int,int[3*XMAX]);
  void set_cursor(int);
  bool is_ende();

  private slots:
  void ticken();
  void droppen();  
  void pfad_zeichnen();
  void pfad_loeschen();

  public slots:
  void neues_spiel();
  void pause();
  void klick(int,int);
  void set_gravi(bool);
  void set_modus(int);
  void save_settings(int);
 
  signals:
  void punkte_changed(int);
  void zeit_changed(int);
  void level_changed(QString);
  void gameover(int); // Punkte weiterreichen und bei Bedarf HSC-Eintrag oder Gameover-Bild (Sprite?)
};

#endif
